import 'package:origami_endpoint/models/sessionConfig/jwtConfig.dart';
import 'package:origami_endpoint/models/sessionConfig/redisConfig.dart';
import 'package:origamicore/models/serializedObject.dart';

class ConnectionProtocol extends SerializedObject
{
  String type;
  int port;
  //if express
  String key;//path of file
  String crt;//path of file
  //if socket
  String socketProtocol;
  JwtConfig jwtConfig;
  RedisConfig redisConfig;
  ConnectionProtocol({this.type,this.port,this.key,this.crt,this.socketProtocol,this.jwtConfig,  });
  @override
  void fromJson(dynamic data)
  { 
    if(data['type']!=null) type=data['type'];
    if(data['port']!=null) port=data['port'];
    if(data['key']!=null) key=data['key'];
    if(data['crt']!=null) crt=data['crt'];
    if(data['socketProtocol']!=null) socketProtocol=data['socketProtocol'];
    if(data['jwtConfig']!=null) jwtConfig=JwtConfig()..fromJson(data['jwtConfig']);
    if(data['redisConfig']!=null) redisConfig=RedisConfig()..fromJson(data['redisConfig']);
  }
  @override
  dynamic toJson()
  { 
  	var data ={};
      data['type']=type; 
      data['port']=port; 
      data['key']=key; 
      data['crt']=crt; 
      data['socketProtocol']=socketProtocol; 
      data['jwtConfig']=jwtConfig?.toJson(); 
      data['redisConfig']=redisConfig?.toJson(); 
  	return data;
  }
}