import 'package:origami_endpoint/base/jwt.dart';
import 'package:origami_endpoint/externalClass/corsac_jwt.dart';
import 'package:origami_endpoint/models/sessionConfig/jwtConfig.dart';
import 'package:origami_endpoint/service/sessionManager/sessionManager.dart';

class JwtSessionManager extends SessionManager
{
  JwtConfig config;
  @override
  Future<Map<String,dynamic>> getSession(String token)async { 
    var signer =  JWTHmacSha256Signer(config.key);
    var decodedToken = JWT.parse(token);
    if(decodedToken.verify(signer))
    {
      var xx= Jwt.parseJwt(token);
      var ss=0;
      return Jwt.parseJwt(token);
    }
    return <String,dynamic>{};
  }
  
  @override
  Future<String> setSession(String token, dynamic value)async {  
    var builder =   JWTBuilder();
    builder 
      ..expiresAt = DateTime.now().add( Duration( seconds: config.secExpireTime))
      ..setClaim('data', value)
      ..getToken();  

    var signer =  JWTHmacSha256Signer(config.key);
    var signedToken = builder.getSignedToken(signer); 
    var stringToken = signedToken.toString();
    return stringToken;
  }

  @override
  Future init(Object _config)async { 
    config=(_config as JwtConfig );
  }

}